--- freedroid-src/dialogs/HF-FirmwareUpdateServer.lua	2015-11-14 12:01:37.679158223 +0000
+++ freedroid-fixed/dialogs/HF-FirmwareUpdateServer.lua	2015-11-18 16:32:47.479324426 +0000
@@ -20,6 +20,17 @@
 local Npc = FDrpg.get_npc()
 local Tux = FDrpg.get_tux()
 
+local function firmware_spencer()
+	if (not HF_FirmwareUpdateServer_Spencer) then
+		--; TRANSLATORS: "hello?"
+		Npc:says(_"*Bzzt*ello?")
+		Tux:says(_"What? What is this?")
+		start_chat("Spencer")
+		Tux:update_quest("Propagating a faulty firmware update", _"Spencer somehow contacted me through the firmware server terminal. From what he told me, it worked - the hostile bots are all deactivated! I am now supposed to stand by for further instructions...")
+		HF_FirmwareUpdateServer_Spencer = true
+	end
+end
+
 return {
 	EveryTime = function()
 		if (not HF_FirmwareUpdateServer_uploaded_faulty_firmware_update) then
@@ -65,16 +76,9 @@
 			if (not HF_FirmwareUpdateServer_uploaded_faulty_firmware_update) then
 				Npc:says(_"Currently deployed firmware is v. 5.0.8+worldto-nogpl.")
 			else
-			--; TRANSLATORS: %s in %swashere  = Tux:get_player_name() 
+				--; TRANSLATORS: %s in %swashere  = Tux:get_player_name() 
 				Npc:says(_"Currently deployed firmware is v. 5.0.8+%swashere+gpl", Tux:get_player_name())
-				if (not HF_FirmwareUpdateServer_Spencer) then
-					--; TRANSLATORS: "hello?"
-					Npc:says(_"*Bzzt*ello?")
-					Tux:says(_"What? What is this?")
-					start_chat("Spencer")
-					Tux:update_quest("Propagating a faulty firmware update", _"Spencer somehow contacted me through the firmware server terminal. From what he told me, it worked - the hostile bots are all deactivated! I am now supposed to stand by for further instructions...")
-					HF_FirmwareUpdateServer_Spencer = true
-				end
+				firmware_spencer()
 			end
 		end,
 	},
@@ -107,6 +111,9 @@
 		id = "node99",
 		text = _"Logout",
 		code = function()
+			if (HF_FirmwareUpdateServer_uploaded_faulty_firmware_update) then
+				firmware_spencer()
+			end
 			play_sound("effects/Menu_Item_Selected_Sound_1.ogg")
 			end_dialog()
 			if (HF_FirmwareUpdateServer_Spencer) and (not HF_Spencer_teleported) then
